package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ServiceTypeDetail;
import com.izouma.awesomeadmin.service.ServiceTypeDetailService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/serviceTypeDetail")
@RequiresAuthentication
public class ServiceTypeDetailController {

    @Autowired
    private ServiceTypeDetailService serviceTypeDetailService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ServiceTypeDetail record) {
        List<ServiceTypeDetail> pp = serviceTypeDetailService.getServiceTypeDetailList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getServiceTypeDetail", method = RequestMethod.GET)
    @ResponseBody
    public Result getServiceTypeDetail(@RequestParam(required = false, value = "id") String id) {
        ServiceTypeDetail data = serviceTypeDetailService.getServiceTypeDetailById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ServiceTypeDetail record) {
        ServiceTypeDetail data = serviceTypeDetailService.getServiceTypeDetail(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ServiceTypeDetail record) {
        Map<String, Object> result = new HashMap<>();

        List<ServiceTypeDetail> pp =serviceTypeDetailService.getServiceTypeDetailByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ServiceTypeDetail record) {
        boolean num = serviceTypeDetailService.createServiceTypeDetail(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateServiceTypeDetail(ServiceTypeDetail record) {
        boolean num = serviceTypeDetailService.updateServiceTypeDetail(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteServiceTypeDetail(@RequestParam(required = true, value = "id") String id) {

        boolean num = serviceTypeDetailService.deleteServiceTypeDetail(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ServiceTypeDetail record) throws Exception {

    List<ServiceTypeDetail> serviceTypeDetails = serviceTypeDetailService.getServiceTypeDetailList(record);


        String sheetName = "service_type_detail";
        String titleName = "服务小类数据表";
        String fileName = "服务小类表";
        int columnNumber = 10;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "父类" ,   "类名" ,   "描述" ,   "排序"  };
        String[][] dataList = new String[serviceTypeDetails.size()][10];

        for (int i = 0; i < serviceTypeDetails.size(); i++) {

                        dataList[i][0] = String.valueOf(serviceTypeDetails.get(i).getId());
                        dataList[i][1] = String.valueOf(serviceTypeDetails.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(serviceTypeDetails.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(serviceTypeDetails.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(serviceTypeDetails.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(serviceTypeDetails.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(serviceTypeDetails.get(i).getParentId());
                        dataList[i][7] = String.valueOf(serviceTypeDetails.get(i).getTypeName());
                        dataList[i][8] = String.valueOf(serviceTypeDetails.get(i).getDescription());
                        dataList[i][9] = String.valueOf(serviceTypeDetails.get(i).getRank());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

